header {
/*
 * ============================================================================
 * Licensed Materials - Property of IBM
 * Project  Zero
 *
 * (C) Copyright IBM Corp. 2007  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 * ============================================================================
 */
 
package zero.core.events.antlr;
}


/* #################################################################### */
/* #                              Lexer                                 */
/* #################################################################### */
{
import antlr.TokenStreamSelector;
}
class ValueLexer extends Lexer;

options {
	k=3;  // k=3 to distinguish GCKeyRef ${/ from VariableRef ${a
	charVocabulary = '\0'..'\ufffe';  // uffff is EOF
	defaultErrorHandler=false;
}

{
TokenStreamSelector _selector = null;
int _openParenCounter = 0;

public void setSelector(TokenStreamSelector selector) {
	_selector = selector;
}
}


RParen
	: {(_openParenCounter == 0)}? ')' {_selector.pop();}
	;

Value
	: (
		'(' {_openParenCounter++;}
		| {(_openParenCounter > 0)}? ')' {_openParenCounter--;}
		| ~('(' | ')') )+
	;
